"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jwt_decode_1 = __importDefault(require("jwt-decode"));
var Misc_1 = require("./../../util/Misc");
var User = /** @class */ (function () {
    function User(jwt) {
        this.jwt = jwt;
        this.permissions = [];
        this.roles = [];
    }
    User.prototype.getJwtToken = function () {
        return this.jwt;
    };
    User.prototype.getPayload = function () {
        return jwt_decode_1.default(this.jwt);
    };
    User.prototype.getHeader = function () {
        return jwt_decode_1.default(this.jwt, { header: true });
    };
    User.prototype.isAuthenticated = function () {
        return !!this.getPayload().isAuth;
    };
    User.prototype.setPermissions = function (permissions) {
        this.permissions = Array.isArray(permissions)
            ? permissions
            : [];
    };
    User.prototype.hasPermission = function (name) {
        return this.permissions.indexOf(Misc_1.md5(name)) !== -1;
    };
    User.prototype.setRoles = function (roles) {
        this.roles = Array.isArray(roles)
            ? roles
            : [];
    };
    User.prototype.hasRole = function (name) {
        return this.roles.indexOf(Misc_1.md5(name)) !== -1;
    };
    return User;
}());
exports.default = User;
//# sourceMappingURL=User.js.map